
varying highp vec2 textureCoordinate;
 
 uniform sampler2D inputImageTexture;
 
 uniform highp vec2 uTexelSize;
 uniform highp float uScanRadius;
 
 highp float rand(highp vec2 co)
{
    highp float a = 12.9898;
    highp float b = 78.233;
    highp float c = 43758.5453;
    highp float dt= dot(co.xy ,vec2(a,b));
    highp float sn= mod(dt,3.14);
    return abs(fract(sin(sn) * c));
}

highp vec2 randVec(highp vec2 texelSize, highp float scanDiam, highp vec2 randSeed1, highp vec2 randSeed2)
{
    highp vec2 rnum1 = vec2(rand(randSeed1), rand(randSeed2));
    return scanDiam*texelSize*rnum1;
}
 
 void main()
{
    //input image
    highp vec4 textureColor0 = texture2D(inputImageTexture, textureCoordinate);
    highp float brightness0 = dot(textureColor0.rgb, vec3(1.0, 1.0, 1.0))/3.0; //brightness of the original image

    //random sample search diameter
    highp float scanDiam = 2.0*uScanRadius;
    //compute the offset corner of the scan area
    highp vec2 scanCorner = vec2(uScanRadius*uTexelSize.x, uScanRadius*uTexelSize.y);
    highp vec2 topLeftCoord = textureCoordinate - scanCorner;
    
    highp vec4 rs = vec4(textureCoordinate.y,textureColor0.r,textureColor0.b,textureColor0.g);
    
    highp vec2 randSeed1x = rs.rg;
    highp vec2 randSeed1y = rs.rb;
    highp vec2 randSeed2x = rs.rr;
    highp vec2 randSeed2y = rs.bb;
    highp vec2 randSeed3x = rs.bg + textureCoordinate.yx;
    highp vec2 randSeed3y = rs.br;
    highp vec2 randSeed4x = rs.gr;
    highp vec2 randSeed4y = rs.gb;
    highp vec2 randSeed5x = rs.gg + textureCoordinate.xy;
    highp vec2 randSeed5y = textureColor0.ra;
    highp vec2 randSeed6x = rs.ba + textureCoordinate.xy;
    highp vec2 randSeed6y = rs.ga - textureCoordinate.xy;
    highp vec2 randSeed7x = rs.aa - textureCoordinate.xy;
    highp vec2 randSeed7y = textureColor0.ab + textureCoordinate.xy;
    highp vec2 randSeed8x = rs.ab;
    highp vec2 randSeed8y = textureColor0.br;
    highp vec2 randSeed9x = textureColor0.bg - textureCoordinate.xy;
    highp vec2 randSeed9y = rs.bg;
    highp vec2 randSeed10x = rs.gb;
    highp vec2 randSeed10y = textureColor0.gr;
    highp vec2 randSeed11x = rs.ab + textureColor0.gr;
    highp vec2 randSeed11y = rs.rb - textureColor0.gr;
    highp vec2 randSeed12x = rs.ba + textureCoordinate.yx;
    highp vec2 randSeed12y = rs.br - textureColor0.rb;
    
    highp vec2 rCoor1 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed1x, randSeed1y);
    highp vec2 rCoor2 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed2x, randSeed2y);
    highp vec2 rCoor3 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed3x, randSeed2y);
    highp vec2 rCoor4 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed4x, randSeed4y);
    highp vec2 rCoor5 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed5x, randSeed5y);
    highp vec2 rCoor6 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed6x, randSeed6y);
    highp vec2 rCoor7 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed7x, randSeed7y);
    highp vec2 rCoor8 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed8x, randSeed8y);
    highp vec2 rCoor9 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed9x, randSeed9y);
    highp vec2 rCoor10 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed10x, randSeed10y);
    highp vec2 rCoor11 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed11x, randSeed11y);
    highp vec2 rCoor12 = topLeftCoord + randVec(uTexelSize, scanDiam, randSeed12x, randSeed12y);
    
    highp vec4 textureColor1  = texture2D(inputImageTexture, rCoor1);
    highp vec4 textureColor2  = texture2D(inputImageTexture, rCoor2);
    highp vec4 textureColor3  = texture2D(inputImageTexture, rCoor3);
    highp vec4 textureColor4  = texture2D(inputImageTexture, rCoor4);
    highp vec4 textureColor5  = texture2D(inputImageTexture, rCoor5);
    highp vec4 textureColor6  = texture2D(inputImageTexture, rCoor6);
    highp vec4 textureColor7  = texture2D(inputImageTexture, rCoor7);
    highp vec4 textureColor8  = texture2D(inputImageTexture, rCoor8);
    highp vec4 textureColor9  = texture2D(inputImageTexture, rCoor9);
    highp vec4 textureColor10 = texture2D(inputImageTexture, rCoor10);
    highp vec4 textureColor11 = texture2D(inputImageTexture, rCoor11);
    highp vec4 textureColor12 = texture2D(inputImageTexture, rCoor12);

    highp float brightness1 = dot(textureColor1.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness2 = dot(textureColor2.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness3 = dot(textureColor3.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness4 = dot(textureColor4.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness5 = dot(textureColor5.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness6 = dot(textureColor6.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness7 = dot(textureColor7.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness8 = dot(textureColor8.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness9 = dot(textureColor9.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness10 = dot(textureColor10.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness11 = dot(textureColor11.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    highp float brightness12 = dot(textureColor12.rgb, vec3(1.0, 1.0, 1.0))/3.0;
    
    //Generate modifiers for each pixel (0 if darker, 1 if brighter)
    highp float mod1 = sign(brightness1 - brightness0)/2.0 + 0.5;
    highp float mod2 = sign(brightness2 - brightness0)/2.0 + 0.5;
    highp float mod3 = sign(brightness3 - brightness0)/2.0 + 0.5;
    highp float mod4 = sign(brightness4 - brightness0)/2.0 + 0.5;
    highp float mod5 = sign(brightness5 - brightness0)/2.0 + 0.5;
    highp float mod6 = sign(brightness6 - brightness0)/2.0 + 0.5;
    highp float mod7 = sign(brightness7 - brightness0)/2.0 + 0.5;
    highp float mod8 = sign(brightness8 - brightness0)/2.0 + 0.5;
    highp float mod9 = sign(brightness9 - brightness0)/2.0 + 0.5;
    highp float mod10 = sign(brightness10 - brightness0)/2.0 + 0.5;
    highp float mod11 = sign(brightness11 - brightness0)/2.0 + 0.5;
    highp float mod12 = sign(brightness12 - brightness0)/2.0 + 0.5;

    highp float modifier = mod1+mod2+mod3+mod4+mod5+mod6+mod7+mod8+mod9+mod10+mod11+mod12;
    highp float sig = 1.0 - abs(sign(modifier));
    modifier = modifier + sig;
    
    highp float mixer = sign(modifier - 8.0); ///2.0 + 0.5;
    mixer = mixer + (1.0 - abs(mixer));
    mixer = mixer / 2.0 + 0.5;

    highp vec4 targetColor = mod1 * textureColor1 + mod2 * textureColor2 + mod3 * textureColor3 + mod4 * textureColor4 + mod5 * textureColor5 + mod6 * textureColor6 + mod7 * textureColor7 + mod8 * textureColor8 + mod9 * textureColor9 + mod10 * textureColor10 + mod11 * textureColor11 + mod12 * textureColor12;
    targetColor = targetColor / modifier;
    
    highp vec4 outColor = vec4(mix(textureColor0.rgb,targetColor.rgb,mixer),textureColor0.a);
    gl_FragColor = outColor;
}

