varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

void main()
{
    highp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    
    highp float targetBrightness = 1.0;
    highp float textureBrightness = dot(textureColor.rgb,vec3(0.34,0.33,0.33))/3.0;
    
	highp float brightnessDifference = targetBrightness - textureBrightness;
	highp float brightnessIncrease = pow(brightnessDifference, 10.0) * ( (1.0 - brightnessDifference) * 0.5 + 0.5);
	
    
    highp vec4 outColor;
    outColor.rgb = (textureColor.rgb + vec3(brightnessIncrease,brightnessIncrease,brightnessIncrease));
    outColor.rgb = clamp(outColor.rgb,0.0,1.0);
    outColor.a = textureColor.a;
    gl_FragColor = outColor;
}